diff -urNp linux-2.6.32.24/drivers/mtd/ubi/build.c linux-2.6.32.24/drivers/mtd/ubi/build.c
--- linux-2.6.32.24/drivers/mtd/ubi/build.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/mtd/ubi/build.c	2010-09-04 15:54:52.000000000 -0400
@@ -1255,7 +1255,7 @@ module_exit(ubi_exit);
 static int __init bytes_str_to_int(const char *str)
 {
 	char *endp;
-	unsigned long result;
+	unsigned long result, scale = 1;
 
 	result = simple_strtoul(str, &endp, 0);
 	if (str == endp || result >= INT_MAX) {
@@ -1266,11 +1266,11 @@ static int __init bytes_str_to_int(const
 
 	switch (*endp) {
 	case 'G':
-		result *= 1024;
+		scale *= 1024;
 	case 'M':
-		result *= 1024;
+		scale *= 1024;
 	case 'K':
-		result *= 1024;
+		scale *= 1024;
 		if (endp[1] == 'i' && endp[2] == 'B')
 			endp += 2;
 	case '\0':
@@ -1281,7 +1281,13 @@ static int __init bytes_str_to_int(const
 		return -EINVAL;
 	}
 
-	return result;
+	if ((intoverflow_t)result*scale >= INT_MAX) {
+		printk(KERN_ERR "UBI error: incorrect bytes count: \"%s\"\n",
+		       str);
+		return -EINVAL;
+	}
+
+	return result*scale;
 }
 
 /**
diff -urNp linux-2.6.32.24/drivers/net/cxgb3/cxgb3_main.c linux-2.6.32.24/drivers/net/cxgb3/cxgb3_main.c
--- linux-2.6.32.24/drivers/net/cxgb3/cxgb3_main.c	2010-09-26 17:26:05.000000000 -0400
+++ linux-2.6.32.24/drivers/net/cxgb3/cxgb3_main.c	2010-09-26 17:26:38.000000000 -0400
@@ -2275,7 +2275,7 @@ static int cxgb_extension_ioctl(struct n
 	case CHELSIO_GET_QSET_NUM:{
 		struct ch_reg edata;
 
-		memset(&edata, 0, sizeof(struct ch_reg));
+		memset(&edata, 0, sizeof(edata));
 
 		edata.cmd = CHELSIO_GET_QSET_NUM;
 		edata.val = pi->nqsets;
diff -urNp linux-2.6.32.24/drivers/net/e1000e/82571.c linux-2.6.32.24/drivers/net/e1000e/82571.c
--- linux-2.6.32.24/drivers/net/e1000e/82571.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/net/e1000e/82571.c	2010-09-04 15:54:52.000000000 -0400
@@ -212,6 +212,7 @@ static s32 e1000_init_mac_params_82571(s
 {
 	struct e1000_hw *hw = &adapter->hw;
 	struct e1000_mac_info *mac = &hw->mac;
+	/* cannot be const */
 	struct e1000_mac_operations *func = &mac->ops;
 	u32 swsm = 0;
 	u32 swsm2 = 0;
@@ -1656,7 +1657,7 @@ static void e1000_clear_hw_cntrs_82571(s
 	temp = er32(ICRXDMTC);
 }
 
-static struct e1000_mac_operations e82571_mac_ops = {
+static const struct e1000_mac_operations e82571_mac_ops = {
 	/* .check_mng_mode: mac type dependent */
 	/* .check_for_link: media type dependent */
 	.id_led_init		= e1000e_id_led_init,
@@ -1674,7 +1675,7 @@ static struct e1000_mac_operations e8257
 	.setup_led		= e1000e_setup_led_generic,
 };
 
-static struct e1000_phy_operations e82_phy_ops_igp = {
+static const struct e1000_phy_operations e82_phy_ops_igp = {
 	.acquire_phy		= e1000_get_hw_semaphore_82571,
 	.check_reset_block	= e1000e_check_reset_block_generic,
 	.commit_phy		= NULL,
@@ -1691,7 +1692,7 @@ static struct e1000_phy_operations e82_p
 	.cfg_on_link_up      	= NULL,
 };
 
-static struct e1000_phy_operations e82_phy_ops_m88 = {
+static const struct e1000_phy_operations e82_phy_ops_m88 = {
 	.acquire_phy		= e1000_get_hw_semaphore_82571,
 	.check_reset_block	= e1000e_check_reset_block_generic,
 	.commit_phy		= e1000e_phy_sw_reset,
@@ -1708,7 +1709,7 @@ static struct e1000_phy_operations e82_p
 	.cfg_on_link_up      	= NULL,
 };
 
-static struct e1000_phy_operations e82_phy_ops_bm = {
+static const struct e1000_phy_operations e82_phy_ops_bm = {
 	.acquire_phy		= e1000_get_hw_semaphore_82571,
 	.check_reset_block	= e1000e_check_reset_block_generic,
 	.commit_phy		= e1000e_phy_sw_reset,
@@ -1725,7 +1726,7 @@ static struct e1000_phy_operations e82_p
 	.cfg_on_link_up      	= NULL,
 };
 
-static struct e1000_nvm_operations e82571_nvm_ops = {
+static const struct e1000_nvm_operations e82571_nvm_ops = {
 	.acquire_nvm		= e1000_acquire_nvm_82571,
 	.read_nvm		= e1000e_read_nvm_eerd,
 	.release_nvm		= e1000_release_nvm_82571,
diff -urNp linux-2.6.32.24/drivers/net/e1000e/e1000.h linux-2.6.32.24/drivers/net/e1000e/e1000.h
--- linux-2.6.32.24/drivers/net/e1000e/e1000.h	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/net/e1000e/e1000.h	2010-09-04 15:54:52.000000000 -0400
@@ -375,9 +375,9 @@ struct e1000_info {
 	u32			pba;
 	u32			max_hw_frame_size;
 	s32			(*get_variants)(struct e1000_adapter *);
-	struct e1000_mac_operations *mac_ops;
-	struct e1000_phy_operations *phy_ops;
-	struct e1000_nvm_operations *nvm_ops;
+	const struct e1000_mac_operations *mac_ops;
+	const struct e1000_phy_operations *phy_ops;
+	const struct e1000_nvm_operations *nvm_ops;
 };
 
 /* hardware capability, feature, and workaround flags */
diff -urNp linux-2.6.32.24/drivers/net/e1000e/es2lan.c linux-2.6.32.24/drivers/net/e1000e/es2lan.c
--- linux-2.6.32.24/drivers/net/e1000e/es2lan.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/net/e1000e/es2lan.c	2010-09-04 15:54:52.000000000 -0400
@@ -207,6 +207,7 @@ static s32 e1000_init_mac_params_80003es
 {
 	struct e1000_hw *hw = &adapter->hw;
 	struct e1000_mac_info *mac = &hw->mac;
+	/* cannot be const */
 	struct e1000_mac_operations *func = &mac->ops;
 
 	/* Set media type */
@@ -1365,7 +1366,7 @@ static void e1000_clear_hw_cntrs_80003es
 	temp = er32(ICRXDMTC);
 }
 
-static struct e1000_mac_operations es2_mac_ops = {
+static const struct e1000_mac_operations es2_mac_ops = {
 	.id_led_init		= e1000e_id_led_init,
 	.check_mng_mode		= e1000e_check_mng_mode_generic,
 	/* check_for_link dependent on media type */
@@ -1383,7 +1384,7 @@ static struct e1000_mac_operations es2_m
 	.setup_led		= e1000e_setup_led_generic,
 };
 
-static struct e1000_phy_operations es2_phy_ops = {
+static const struct e1000_phy_operations es2_phy_ops = {
 	.acquire_phy		= e1000_acquire_phy_80003es2lan,
 	.check_reset_block	= e1000e_check_reset_block_generic,
 	.commit_phy	 	= e1000e_phy_sw_reset,
@@ -1400,7 +1401,7 @@ static struct e1000_phy_operations es2_p
 	.cfg_on_link_up      	= e1000_cfg_on_link_up_80003es2lan,
 };
 
-static struct e1000_nvm_operations es2_nvm_ops = {
+static const struct e1000_nvm_operations es2_nvm_ops = {
 	.acquire_nvm		= e1000_acquire_nvm_80003es2lan,
 	.read_nvm		= e1000e_read_nvm_eerd,
 	.release_nvm		= e1000_release_nvm_80003es2lan,
diff -urNp linux-2.6.32.24/drivers/net/e1000e/hw.h linux-2.6.32.24/drivers/net/e1000e/hw.h
--- linux-2.6.32.24/drivers/net/e1000e/hw.h	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/net/e1000e/hw.h	2010-09-04 15:54:52.000000000 -0400
@@ -756,34 +756,34 @@ struct e1000_mac_operations {
 
 /* Function pointers for the PHY. */
 struct e1000_phy_operations {
-	s32  (*acquire_phy)(struct e1000_hw *);
-	s32  (*check_polarity)(struct e1000_hw *);
-	s32  (*check_reset_block)(struct e1000_hw *);
-	s32  (*commit_phy)(struct e1000_hw *);
-	s32  (*force_speed_duplex)(struct e1000_hw *);
-	s32  (*get_cfg_done)(struct e1000_hw *hw);
-	s32  (*get_cable_length)(struct e1000_hw *);
-	s32  (*get_phy_info)(struct e1000_hw *);
-	s32  (*read_phy_reg)(struct e1000_hw *, u32, u16 *);
-	s32  (*read_phy_reg_locked)(struct e1000_hw *, u32, u16 *);
-	void (*release_phy)(struct e1000_hw *);
-	s32  (*reset_phy)(struct e1000_hw *);
-	s32  (*set_d0_lplu_state)(struct e1000_hw *, bool);
-	s32  (*set_d3_lplu_state)(struct e1000_hw *, bool);
-	s32  (*write_phy_reg)(struct e1000_hw *, u32, u16);
-	s32  (*write_phy_reg_locked)(struct e1000_hw *, u32, u16);
-	s32  (*cfg_on_link_up)(struct e1000_hw *);
+	s32  (* acquire_phy)(struct e1000_hw *);
+	s32  (* check_polarity)(struct e1000_hw *);
+	s32  (* check_reset_block)(struct e1000_hw *);
+	s32  (* commit_phy)(struct e1000_hw *);
+	s32  (* force_speed_duplex)(struct e1000_hw *);
+	s32  (* get_cfg_done)(struct e1000_hw *hw);
+	s32  (* get_cable_length)(struct e1000_hw *);
+	s32  (* get_phy_info)(struct e1000_hw *);
+	s32  (* read_phy_reg)(struct e1000_hw *, u32, u16 *);
+	s32  (* read_phy_reg_locked)(struct e1000_hw *, u32, u16 *);
+	void (* release_phy)(struct e1000_hw *);
+	s32  (* reset_phy)(struct e1000_hw *);
+	s32  (* set_d0_lplu_state)(struct e1000_hw *, bool);
+	s32  (* set_d3_lplu_state)(struct e1000_hw *, bool);
+	s32  (* write_phy_reg)(struct e1000_hw *, u32, u16);
+	s32  (* write_phy_reg_locked)(struct e1000_hw *, u32, u16);
+	s32  (* cfg_on_link_up)(struct e1000_hw *);
 };
 
 /* Function pointers for the NVM. */
 struct e1000_nvm_operations {
-	s32  (*acquire_nvm)(struct e1000_hw *);
-	s32  (*read_nvm)(struct e1000_hw *, u16, u16, u16 *);
-	void (*release_nvm)(struct e1000_hw *);
-	s32  (*update_nvm)(struct e1000_hw *);
-	s32  (*valid_led_default)(struct e1000_hw *, u16 *);
-	s32  (*validate_nvm)(struct e1000_hw *);
-	s32  (*write_nvm)(struct e1000_hw *, u16, u16, u16 *);
+	s32  (* const acquire_nvm)(struct e1000_hw *);
+	s32  (* const read_nvm)(struct e1000_hw *, u16, u16, u16 *);
+	void (* const release_nvm)(struct e1000_hw *);
+	s32  (* const update_nvm)(struct e1000_hw *);
+	s32  (* const valid_led_default)(struct e1000_hw *, u16 *);
+	s32  (* const validate_nvm)(struct e1000_hw *);
+	s32  (* const write_nvm)(struct e1000_hw *, u16, u16, u16 *);
 };
 
 struct e1000_mac_info {
diff -urNp linux-2.6.32.24/drivers/net/e1000e/ich8lan.c linux-2.6.32.24/drivers/net/e1000e/ich8lan.c
--- linux-2.6.32.24/drivers/net/e1000e/ich8lan.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/net/e1000e/ich8lan.c	2010-09-04 15:54:52.000000000 -0400
@@ -3452,7 +3452,7 @@ static void e1000_clear_hw_cntrs_ich8lan
 	}
 }
 
-static struct e1000_mac_operations ich8_mac_ops = {
+static const struct e1000_mac_operations ich8_mac_ops = {
 	.id_led_init		= e1000e_id_led_init,
 	.check_mng_mode		= e1000_check_mng_mode_ich8lan,
 	.check_for_link		= e1000_check_for_copper_link_ich8lan,
@@ -3470,7 +3470,7 @@ static struct e1000_mac_operations ich8_
 	/* id_led_init dependent on mac type */
 };
 
-static struct e1000_phy_operations ich8_phy_ops = {
+static const struct e1000_phy_operations ich8_phy_ops = {
 	.acquire_phy		= e1000_acquire_swflag_ich8lan,
 	.check_reset_block	= e1000_check_reset_block_ich8lan,
 	.commit_phy		= NULL,
@@ -3486,7 +3486,7 @@ static struct e1000_phy_operations ich8_
 	.write_phy_reg		= e1000e_write_phy_reg_igp,
 };
 
-static struct e1000_nvm_operations ich8_nvm_ops = {
+static const struct e1000_nvm_operations ich8_nvm_ops = {
 	.acquire_nvm		= e1000_acquire_nvm_ich8lan,
 	.read_nvm	 	= e1000_read_nvm_ich8lan,
 	.release_nvm		= e1000_release_nvm_ich8lan,
diff -urNp linux-2.6.32.24/drivers/net/eql.c linux-2.6.32.24/drivers/net/eql.c
--- linux-2.6.32.24/drivers/net/eql.c	2010-09-26 17:26:05.000000000 -0400
+++ linux-2.6.32.24/drivers/net/eql.c	2010-09-26 17:26:38.000000000 -0400
@@ -554,7 +554,7 @@ static int eql_g_master_cfg(struct net_d
 	equalizer_t *eql;
 	master_config_t mc;
 
-	memset(&mc, 0, sizeof(master_config_t));
+	memset(&mc, 0, sizeof(mc));
 
 	if (eql_is_master(dev)) {
 		eql = netdev_priv(dev);
diff -urNp linux-2.6.32.24/drivers/net/ibmveth.c linux-2.6.32.24/drivers/net/ibmveth.c
--- linux-2.6.32.24/drivers/net/ibmveth.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/net/ibmveth.c	2010-09-04 15:54:52.000000000 -0400
@@ -1577,7 +1577,7 @@ static struct attribute * veth_pool_attr
 	NULL,
 };
 
-static struct sysfs_ops veth_pool_ops = {
+static const struct sysfs_ops veth_pool_ops = {
 	.show   = veth_pool_show,
 	.store  = veth_pool_store,
 };
diff -urNp linux-2.6.32.24/drivers/net/igb/e1000_82575.c linux-2.6.32.24/drivers/net/igb/e1000_82575.c
--- linux-2.6.32.24/drivers/net/igb/e1000_82575.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/net/igb/e1000_82575.c	2010-09-04 15:54:52.000000000 -0400
@@ -1410,7 +1410,7 @@ void igb_vmdq_set_replication_pf(struct 
 	wr32(E1000_VT_CTL, vt_ctl);
 }
 
-static struct e1000_mac_operations e1000_mac_ops_82575 = {
+static const struct e1000_mac_operations e1000_mac_ops_82575 = {
 	.reset_hw             = igb_reset_hw_82575,
 	.init_hw              = igb_init_hw_82575,
 	.check_for_link       = igb_check_for_link_82575,
@@ -1419,13 +1419,13 @@ static struct e1000_mac_operations e1000
 	.get_speed_and_duplex = igb_get_speed_and_duplex_copper,
 };
 
-static struct e1000_phy_operations e1000_phy_ops_82575 = {
+static const struct e1000_phy_operations e1000_phy_ops_82575 = {
 	.acquire              = igb_acquire_phy_82575,
 	.get_cfg_done         = igb_get_cfg_done_82575,
 	.release              = igb_release_phy_82575,
 };
 
-static struct e1000_nvm_operations e1000_nvm_ops_82575 = {
+static const struct e1000_nvm_operations e1000_nvm_ops_82575 = {
 	.acquire              = igb_acquire_nvm_82575,
 	.read                 = igb_read_nvm_eerd,
 	.release              = igb_release_nvm_82575,
diff -urNp linux-2.6.32.24/drivers/net/igb/e1000_hw.h linux-2.6.32.24/drivers/net/igb/e1000_hw.h
--- linux-2.6.32.24/drivers/net/igb/e1000_hw.h	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/net/igb/e1000_hw.h	2010-09-04 15:54:52.000000000 -0400
@@ -305,17 +305,17 @@ struct e1000_phy_operations {
 };
 
 struct e1000_nvm_operations {
-	s32  (*acquire)(struct e1000_hw *);
-	s32  (*read)(struct e1000_hw *, u16, u16, u16 *);
-	void (*release)(struct e1000_hw *);
-	s32  (*write)(struct e1000_hw *, u16, u16, u16 *);
+	s32  (* const acquire)(struct e1000_hw *);
+	s32  (* const read)(struct e1000_hw *, u16, u16, u16 *);
+	void (* const release)(struct e1000_hw *);
+	s32  (* const write)(struct e1000_hw *, u16, u16, u16 *);
 };
 
 struct e1000_info {
 	s32 (*get_invariants)(struct e1000_hw *);
-	struct e1000_mac_operations *mac_ops;
-	struct e1000_phy_operations *phy_ops;
-	struct e1000_nvm_operations *nvm_ops;
+	const struct e1000_mac_operations *mac_ops;
+	const struct e1000_phy_operations *phy_ops;
+	const struct e1000_nvm_operations *nvm_ops;
 };
 
 extern const struct e1000_info e1000_82575_info;
diff -urNp linux-2.6.32.24/drivers/net/irda/vlsi_ir.c linux-2.6.32.24/drivers/net/irda/vlsi_ir.c
--- linux-2.6.32.24/drivers/net/irda/vlsi_ir.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/net/irda/vlsi_ir.c	2010-09-04 15:54:52.000000000 -0400
@@ -907,13 +907,12 @@ static netdev_tx_t vlsi_hard_start_xmit(
 			/* no race - tx-ring already empty */
 			vlsi_set_baud(idev, iobase);
 			netif_wake_queue(ndev);
-		}
-		else
-			;
+		} else {
 			/* keep the speed change pending like it would
 			 * for any len>0 packet. tx completion interrupt
 			 * will apply it when the tx ring becomes empty.
 			 */
+		}
 		spin_unlock_irqrestore(&idev->lock, flags);
 		dev_kfree_skb_any(skb);
 		return NETDEV_TX_OK;
diff -urNp linux-2.6.32.24/drivers/net/iseries_veth.c linux-2.6.32.24/drivers/net/iseries_veth.c
--- linux-2.6.32.24/drivers/net/iseries_veth.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/net/iseries_veth.c	2010-09-04 15:54:52.000000000 -0400
@@ -384,7 +384,7 @@ static struct attribute *veth_cnx_defaul
 	NULL
 };
 
-static struct sysfs_ops veth_cnx_sysfs_ops = {
+static const struct sysfs_ops veth_cnx_sysfs_ops = {
 		.show = veth_cnx_attribute_show
 };
 
@@ -441,7 +441,7 @@ static struct attribute *veth_port_defau
 	NULL
 };
 
-static struct sysfs_ops veth_port_sysfs_ops = {
+static const struct sysfs_ops veth_port_sysfs_ops = {
 	.show = veth_port_attribute_show
 };
 
diff -urNp linux-2.6.32.24/drivers/net/pcnet32.c linux-2.6.32.24/drivers/net/pcnet32.c
--- linux-2.6.32.24/drivers/net/pcnet32.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/net/pcnet32.c	2010-09-04 15:54:52.000000000 -0400
@@ -79,7 +79,7 @@ static int cards_found;
 /*
  * VLB I/O addresses
  */
-static unsigned int pcnet32_portlist[] __initdata =
+static unsigned int pcnet32_portlist[] __devinitdata =
     { 0x300, 0x320, 0x340, 0x360, 0 };
 
 static int pcnet32_debug = 0;
diff -urNp linux-2.6.32.24/drivers/net/tg3.h linux-2.6.32.24/drivers/net/tg3.h
--- linux-2.6.32.24/drivers/net/tg3.h	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/net/tg3.h	2010-09-04 15:54:52.000000000 -0400
@@ -95,6 +95,7 @@
 #define  CHIPREV_ID_5750_A0		 0x4000
 #define  CHIPREV_ID_5750_A1		 0x4001
 #define  CHIPREV_ID_5750_A3		 0x4003
+#define  CHIPREV_ID_5750_C1		 0x4201
 #define  CHIPREV_ID_5750_C2		 0x4202
 #define  CHIPREV_ID_5752_A0_HW		 0x5000
 #define  CHIPREV_ID_5752_A0		 0x6000
diff -urNp linux-2.6.32.24/drivers/net/tulip/de4x5.c linux-2.6.32.24/drivers/net/tulip/de4x5.c
--- linux-2.6.32.24/drivers/net/tulip/de4x5.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/net/tulip/de4x5.c	2010-09-16 14:26:16.000000000 -0400
@@ -5472,7 +5472,7 @@ de4x5_ioctl(struct net_device *dev, stru
 	for (i=0; i<ETH_ALEN; i++) {
 	    tmp.addr[i] = dev->dev_addr[i];
 	}
-	if (copy_to_user(ioc->data, tmp.addr, ioc->len)) return -EFAULT;
+	if (ioc->len > sizeof tmp.addr || copy_to_user(ioc->data, tmp.addr, ioc->len)) return -EFAULT;
 	break;
 
     case DE4X5_SET_HWADDR:           /* Set the hardware address */
@@ -5512,7 +5512,7 @@ de4x5_ioctl(struct net_device *dev, stru
 	spin_lock_irqsave(&lp->lock, flags);
 	memcpy(&statbuf, &lp->pktStats, ioc->len);
 	spin_unlock_irqrestore(&lp->lock, flags);
-	if (copy_to_user(ioc->data, &statbuf, ioc->len))
+	if (ioc->len > sizeof statbuf || copy_to_user(ioc->data, &statbuf, ioc->len))
 		return -EFAULT;
 	break;
     }
@@ -5545,7 +5545,7 @@ de4x5_ioctl(struct net_device *dev, stru
 	tmp.lval[6] = inl(DE4X5_STRR); j+=4;
 	tmp.lval[7] = inl(DE4X5_SIGR); j+=4;
 	ioc->len = j;
-	if (copy_to_user(ioc->data, tmp.addr, ioc->len)) return -EFAULT;
+	if (copy_to_user(ioc->data, tmp.lval, ioc->len)) return -EFAULT;
 	break;
 
 #define DE4X5_DUMP              0x0f /* Dump the DE4X5 Status */
diff -urNp linux-2.6.32.24/drivers/net/usb/hso.c linux-2.6.32.24/drivers/net/usb/hso.c
--- linux-2.6.32.24/drivers/net/usb/hso.c	2010-09-26 17:26:05.000000000 -0400
+++ linux-2.6.32.24/drivers/net/usb/hso.c	2010-09-26 17:26:38.000000000 -0400
@@ -258,7 +258,7 @@ struct hso_serial {
 
 	/* from usb_serial_port */
 	struct tty_struct *tty;
-	int open_count;
+	atomic_t open_count;
 	spinlock_t serial_lock;
 
 	int (*write_data) (struct hso_serial *serial);
@@ -1180,7 +1180,7 @@ static void put_rxbuf_data_and_resubmit_
 	struct urb *urb;
 
 	urb = serial->rx_urb[0];
-	if (serial->open_count > 0) {
+	if (atomic_read(&serial->open_count) > 0) {
 		count = put_rxbuf_data(urb, serial);
 		if (count == -1)
 			return;
@@ -1216,7 +1216,7 @@ static void hso_std_serial_read_bulk_cal
 	DUMP1(urb->transfer_buffer, urb->actual_length);
 
 	/* Anyone listening? */
-	if (serial->open_count == 0)
+	if (atomic_read(&serial->open_count) == 0)
 		return;
 
 	if (status == 0) {
@@ -1311,8 +1311,7 @@ static int hso_serial_open(struct tty_st
 	spin_unlock_irq(&serial->serial_lock);
 
 	/* check for port already opened, if not set the termios */
-	serial->open_count++;
-	if (serial->open_count == 1) {
+	if (atomic_inc_return(&serial->open_count) == 1) {
 		tty->low_latency = 1;
 		serial->rx_state = RX_IDLE;
 		/* Force default termio settings */
@@ -1325,7 +1324,7 @@ static int hso_serial_open(struct tty_st
 		result = hso_start_serial_device(serial->parent, GFP_KERNEL);
 		if (result) {
 			hso_stop_serial_device(serial->parent);
-			serial->open_count--;
+			atomic_dec(&serial->open_count);
 			kref_put(&serial->parent->ref, hso_serial_ref_free);
 		}
 	} else {
@@ -1362,10 +1361,10 @@ static void hso_serial_close(struct tty_
 
 	/* reset the rts and dtr */
 	/* do the actual close */
-	serial->open_count--;
+	atomic_dec(&serial->open_count);
 
-	if (serial->open_count <= 0) {
-		serial->open_count = 0;
+	if (atomic_read(&serial->open_count) <= 0) {
+		atomic_set(&serial->open_count,  0);
 		spin_lock_irq(&serial->serial_lock);
 		if (serial->tty == tty) {
 			serial->tty->driver_data = NULL;
@@ -1447,7 +1446,7 @@ static void hso_serial_set_termios(struc
 
 	/* the actual setup */
 	spin_lock_irqsave(&serial->serial_lock, flags);
-	if (serial->open_count)
+	if (atomic_read(&serial->open_count))
 		_hso_serial_set_termios(tty, old);
 	else
 		tty->termios = old;
@@ -1634,10 +1633,11 @@ static int hso_get_count(struct hso_seri
 	struct uart_icount cnow;
 	struct hso_tiocmget  *tiocmget = serial->tiocmget;
 
-	memset(&icount, 0, sizeof(struct serial_icounter_struct));
-
 	if (!tiocmget)
 		 return -ENOENT;
+
+	memset(&icount, 0, sizeof(icount));
+
 	spin_lock_irq(&serial->serial_lock);
 	memcpy(&cnow, &tiocmget->icount, sizeof(struct uart_icount));
 	spin_unlock_irq(&serial->serial_lock);
@@ -3097,7 +3097,7 @@ static int hso_resume(struct usb_interfa
 	/* Start all serial ports */
 	for (i = 0; i < HSO_SERIAL_TTY_MINORS; i++) {
 		if (serial_table[i] && (serial_table[i]->interface == iface)) {
-			if (dev2ser(serial_table[i])->open_count) {
+			if (atomic_read(&dev2ser(serial_table[i])->open_count)) {
 				result =
 				    hso_start_serial_device(serial_table[i], GFP_NOIO);
 				hso_kick_transmit(dev2ser(serial_table[i]));
diff -urNp linux-2.6.32.24/drivers/net/wireless/b43/debugfs.c linux-2.6.32.24/drivers/net/wireless/b43/debugfs.c
--- linux-2.6.32.24/drivers/net/wireless/b43/debugfs.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/net/wireless/b43/debugfs.c	2010-09-04 15:54:52.000000000 -0400
@@ -43,7 +43,7 @@ static struct dentry *rootdir;
 struct b43_debugfs_fops {
 	ssize_t (*read)(struct b43_wldev *dev, char *buf, size_t bufsize);
 	int (*write)(struct b43_wldev *dev, const char *buf, size_t count);
-	struct file_operations fops;
+	const struct file_operations fops;
 	/* Offset of struct b43_dfs_file in struct b43_dfsentry */
 	size_t file_struct_offset;
 };
diff -urNp linux-2.6.32.24/drivers/net/wireless/b43legacy/debugfs.c linux-2.6.32.24/drivers/net/wireless/b43legacy/debugfs.c
--- linux-2.6.32.24/drivers/net/wireless/b43legacy/debugfs.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/net/wireless/b43legacy/debugfs.c	2010-09-04 15:54:52.000000000 -0400
@@ -44,7 +44,7 @@ static struct dentry *rootdir;
 struct b43legacy_debugfs_fops {
 	ssize_t (*read)(struct b43legacy_wldev *dev, char *buf, size_t bufsize);
 	int (*write)(struct b43legacy_wldev *dev, const char *buf, size_t count);
-	struct file_operations fops;
+	const struct file_operations fops;
 	/* Offset of struct b43legacy_dfs_file in struct b43legacy_dfsentry */
 	size_t file_struct_offset;
 	/* Take wl->irq_lock before calling read/write? */
diff -urNp linux-2.6.32.24/drivers/net/wireless/iwlwifi/iwl-1000.c linux-2.6.32.24/drivers/net/wireless/iwlwifi/iwl-1000.c
--- linux-2.6.32.24/drivers/net/wireless/iwlwifi/iwl-1000.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/net/wireless/iwlwifi/iwl-1000.c	2010-09-04 15:54:52.000000000 -0400
@@ -137,7 +137,7 @@ static struct iwl_lib_ops iwl1000_lib = 
 	 },
 };
 
-static struct iwl_ops iwl1000_ops = {
+static const struct iwl_ops iwl1000_ops = {
 	.ucode = &iwl5000_ucode,
 	.lib = &iwl1000_lib,
 	.hcmd = &iwl5000_hcmd,
diff -urNp linux-2.6.32.24/drivers/net/wireless/iwlwifi/iwl-3945.c linux-2.6.32.24/drivers/net/wireless/iwlwifi/iwl-3945.c
--- linux-2.6.32.24/drivers/net/wireless/iwlwifi/iwl-3945.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/net/wireless/iwlwifi/iwl-3945.c	2010-09-04 15:54:52.000000000 -0400
@@ -2874,7 +2874,7 @@ static struct iwl_hcmd_utils_ops iwl3945
 	.build_addsta_hcmd = iwl3945_build_addsta_hcmd,
 };
 
-static struct iwl_ops iwl3945_ops = {
+static const struct iwl_ops iwl3945_ops = {
 	.ucode = &iwl3945_ucode,
 	.lib = &iwl3945_lib,
 	.hcmd = &iwl3945_hcmd,
diff -urNp linux-2.6.32.24/drivers/net/wireless/iwlwifi/iwl-4965.c linux-2.6.32.24/drivers/net/wireless/iwlwifi/iwl-4965.c
--- linux-2.6.32.24/drivers/net/wireless/iwlwifi/iwl-4965.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/net/wireless/iwlwifi/iwl-4965.c	2010-09-04 15:54:52.000000000 -0400
@@ -2345,7 +2345,7 @@ static struct iwl_lib_ops iwl4965_lib = 
 	},
 };
 
-static struct iwl_ops iwl4965_ops = {
+static const struct iwl_ops iwl4965_ops = {
 	.ucode = &iwl4965_ucode,
 	.lib = &iwl4965_lib,
 	.hcmd = &iwl4965_hcmd,
diff -urNp linux-2.6.32.24/drivers/net/wireless/iwlwifi/iwl-5000.c linux-2.6.32.24/drivers/net/wireless/iwlwifi/iwl-5000.c
--- linux-2.6.32.24/drivers/net/wireless/iwlwifi/iwl-5000.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/net/wireless/iwlwifi/iwl-5000.c	2010-09-04 15:54:52.000000000 -0400
@@ -1633,14 +1633,14 @@ static struct iwl_lib_ops iwl5150_lib = 
 	 },
 };
 
-struct iwl_ops iwl5000_ops = {
+const struct iwl_ops iwl5000_ops = {
 	.ucode = &iwl5000_ucode,
 	.lib = &iwl5000_lib,
 	.hcmd = &iwl5000_hcmd,
 	.utils = &iwl5000_hcmd_utils,
 };
 
-static struct iwl_ops iwl5150_ops = {
+static const struct iwl_ops iwl5150_ops = {
 	.ucode = &iwl5000_ucode,
 	.lib = &iwl5150_lib,
 	.hcmd = &iwl5000_hcmd,
diff -urNp linux-2.6.32.24/drivers/net/wireless/iwlwifi/iwl-6000.c linux-2.6.32.24/drivers/net/wireless/iwlwifi/iwl-6000.c
--- linux-2.6.32.24/drivers/net/wireless/iwlwifi/iwl-6000.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/net/wireless/iwlwifi/iwl-6000.c	2010-09-04 15:54:52.000000000 -0400
@@ -146,7 +146,7 @@ static struct iwl_hcmd_utils_ops iwl6000
 	.calc_rssi = iwl5000_calc_rssi,
 };
 
-static struct iwl_ops iwl6000_ops = {
+static const struct iwl_ops iwl6000_ops = {
 	.ucode = &iwl5000_ucode,
 	.lib = &iwl6000_lib,
 	.hcmd = &iwl5000_hcmd,
diff -urNp linux-2.6.32.24/drivers/net/wireless/iwlwifi/iwl-debug.h linux-2.6.32.24/drivers/net/wireless/iwlwifi/iwl-debug.h
--- linux-2.6.32.24/drivers/net/wireless/iwlwifi/iwl-debug.h	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/net/wireless/iwlwifi/iwl-debug.h	2010-09-04 15:54:52.000000000 -0400
@@ -118,8 +118,8 @@ void iwl_dbgfs_unregister(struct iwl_pri
 #endif
 
 #else
-#define IWL_DEBUG(__priv, level, fmt, args...)
-#define IWL_DEBUG_LIMIT(__priv, level, fmt, args...)
+#define IWL_DEBUG(__priv, level, fmt, args...) do {} while (0)
+#define IWL_DEBUG_LIMIT(__priv, level, fmt, args...) do {} while (0)
 static inline void iwl_print_hex_dump(struct iwl_priv *priv, int level,
 				      void *p, u32 len)
 {}
diff -urNp linux-2.6.32.24/drivers/net/wireless/iwlwifi/iwl-dev.h linux-2.6.32.24/drivers/net/wireless/iwlwifi/iwl-dev.h
--- linux-2.6.32.24/drivers/net/wireless/iwlwifi/iwl-dev.h	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/net/wireless/iwlwifi/iwl-dev.h	2010-09-04 15:54:52.000000000 -0400
@@ -68,7 +68,7 @@ struct iwl_tx_queue;
 
 /* shared structures from iwl-5000.c */
 extern struct iwl_mod_params iwl50_mod_params;
-extern struct iwl_ops iwl5000_ops;
+extern const struct iwl_ops iwl5000_ops;
 extern struct iwl_ucode_ops iwl5000_ucode;
 extern struct iwl_lib_ops iwl5000_lib;
 extern struct iwl_hcmd_ops iwl5000_hcmd;
diff -urNp linux-2.6.32.24/drivers/net/wireless/libertas/debugfs.c linux-2.6.32.24/drivers/net/wireless/libertas/debugfs.c
--- linux-2.6.32.24/drivers/net/wireless/libertas/debugfs.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/net/wireless/libertas/debugfs.c	2010-09-04 15:54:52.000000000 -0400
@@ -708,7 +708,7 @@ out_unlock:
 struct lbs_debugfs_files {
 	const char *name;
 	int perm;
-	struct file_operations fops;
+	const struct file_operations fops;
 };
 
 static const struct lbs_debugfs_files debugfs_files[] = {
diff -urNp linux-2.6.32.24/drivers/net/wireless/rndis_wlan.c linux-2.6.32.24/drivers/net/wireless/rndis_wlan.c
--- linux-2.6.32.24/drivers/net/wireless/rndis_wlan.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/net/wireless/rndis_wlan.c	2010-09-04 15:54:52.000000000 -0400
@@ -1176,7 +1176,7 @@ static int set_rts_threshold(struct usbn
 
 	devdbg(usbdev, "set_rts_threshold %i", rts_threshold);
 
-	if (rts_threshold < 0 || rts_threshold > 2347)
+	if (rts_threshold > 2347)
 		rts_threshold = 2347;
 
 	tmp = cpu_to_le32(rts_threshold);
diff -urNp linux-2.6.32.24/drivers/oprofile/buffer_sync.c linux-2.6.32.24/drivers/oprofile/buffer_sync.c
--- linux-2.6.32.24/drivers/oprofile/buffer_sync.c	2010-09-20 17:26:42.000000000 -0400
+++ linux-2.6.32.24/drivers/oprofile/buffer_sync.c	2010-09-20 17:27:14.000000000 -0400
@@ -341,7 +341,7 @@ static void add_data(struct op_entry *en
 		if (cookie == NO_COOKIE)
 			offset = pc;
 		if (cookie == INVALID_COOKIE) {
-			atomic_inc(&oprofile_stats.sample_lost_no_mapping);
+			atomic_inc_unchecked(&oprofile_stats.sample_lost_no_mapping);
 			offset = pc;
 		}
 		if (cookie != last_cookie) {
@@ -385,14 +385,14 @@ add_sample(struct mm_struct *mm, struct 
 	/* add userspace sample */
 
 	if (!mm) {
-		atomic_inc(&oprofile_stats.sample_lost_no_mm);
+		atomic_inc_unchecked(&oprofile_stats.sample_lost_no_mm);
 		return 0;
 	}
 
 	cookie = lookup_dcookie(mm, s->eip, &offset);
 
 	if (cookie == INVALID_COOKIE) {
-		atomic_inc(&oprofile_stats.sample_lost_no_mapping);
+		atomic_inc_unchecked(&oprofile_stats.sample_lost_no_mapping);
 		return 0;
 	}
 
@@ -561,7 +561,7 @@ void sync_buffer(int cpu)
 		/* ignore backtraces if failed to add a sample */
 		if (state == sb_bt_start) {
 			state = sb_bt_ignore;
-			atomic_inc(&oprofile_stats.bt_lost_no_mapping);
+			atomic_inc_unchecked(&oprofile_stats.bt_lost_no_mapping);
 		}
 	}
 	release_mm(mm);
diff -urNp linux-2.6.32.24/drivers/oprofile/event_buffer.c linux-2.6.32.24/drivers/oprofile/event_buffer.c
--- linux-2.6.32.24/drivers/oprofile/event_buffer.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/oprofile/event_buffer.c	2010-09-04 15:54:52.000000000 -0400
@@ -53,7 +53,7 @@ void add_event_entry(unsigned long value
 	}
 
 	if (buffer_pos == buffer_size) {
-		atomic_inc(&oprofile_stats.event_lost_overflow);
+		atomic_inc_unchecked(&oprofile_stats.event_lost_overflow);
 		return;
 	}
 
diff -urNp linux-2.6.32.24/drivers/oprofile/oprof.c linux-2.6.32.24/drivers/oprofile/oprof.c
--- linux-2.6.32.24/drivers/oprofile/oprof.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/oprofile/oprof.c	2010-09-04 15:54:52.000000000 -0400
@@ -110,7 +110,7 @@ static void switch_worker(struct work_st
 	if (oprofile_ops.switch_events())
 		return;
 
-	atomic_inc(&oprofile_stats.multiplex_counter);
+	atomic_inc_unchecked(&oprofile_stats.multiplex_counter);
 	start_switch_worker();
 }
 
diff -urNp linux-2.6.32.24/drivers/oprofile/oprofilefs.c linux-2.6.32.24/drivers/oprofile/oprofilefs.c
--- linux-2.6.32.24/drivers/oprofile/oprofilefs.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/oprofile/oprofilefs.c	2010-09-04 15:54:52.000000000 -0400
@@ -187,7 +187,7 @@ static const struct file_operations atom
 
 
 int oprofilefs_create_ro_atomic(struct super_block *sb, struct dentry *root,
-	char const *name, atomic_t *val)
+	char const *name, atomic_unchecked_t *val)
 {
 	struct dentry *d = __oprofilefs_create_file(sb, root, name,
 						     &atomic_ro_fops, 0444);
diff -urNp linux-2.6.32.24/drivers/oprofile/oprofile_stats.c linux-2.6.32.24/drivers/oprofile/oprofile_stats.c
--- linux-2.6.32.24/drivers/oprofile/oprofile_stats.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/oprofile/oprofile_stats.c	2010-09-04 15:54:52.000000000 -0400
@@ -30,11 +30,11 @@ void oprofile_reset_stats(void)
 		cpu_buf->sample_invalid_eip = 0;
 	}
 
-	atomic_set(&oprofile_stats.sample_lost_no_mm, 0);
-	atomic_set(&oprofile_stats.sample_lost_no_mapping, 0);
-	atomic_set(&oprofile_stats.event_lost_overflow, 0);
-	atomic_set(&oprofile_stats.bt_lost_no_mapping, 0);
-	atomic_set(&oprofile_stats.multiplex_counter, 0);
+	atomic_set_unchecked(&oprofile_stats.sample_lost_no_mm, 0);
+	atomic_set_unchecked(&oprofile_stats.sample_lost_no_mapping, 0);
+	atomic_set_unchecked(&oprofile_stats.event_lost_overflow, 0);
+	atomic_set_unchecked(&oprofile_stats.bt_lost_no_mapping, 0);
+	atomic_set_unchecked(&oprofile_stats.multiplex_counter, 0);
 }
 
 
